// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: baeldung.proto

package model;

public final class StudentProto {
  private StudentProto() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistryLite registry) {
  }

  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
    registerAllExtensions(
        (com.google.protobuf.ExtensionRegistryLite) registry);
  }
  public interface StudentsOrBuilder extends
      // @@protoc_insertion_point(interface_extends:model.Students)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <code>repeated .model.Student account = 1;</code>
     */
    java.util.List<model.StudentProto.Student> 
        getAccountList();
    /**
     * <code>repeated .model.Student account = 1;</code>
     */
    model.StudentProto.Student getAccount(int index);
    /**
     * <code>repeated .model.Student account = 1;</code>
     */
    int getAccountCount();
    /**
     * <code>repeated .model.Student account = 1;</code>
     */
    java.util.List<? extends model.StudentProto.StudentOrBuilder> 
        getAccountOrBuilderList();
    /**
     * <code>repeated .model.Student account = 1;</code>
     */
    model.StudentProto.StudentOrBuilder getAccountOrBuilder(
        int index);
  }
  /**
   * Protobuf type {@code model.Students}
   */
  public  static final class Students extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:model.Students)
      StudentsOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use Students.newBuilder() to construct.
    private Students(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private Students() {
      account_ = java.util.Collections.emptyList();
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new Students();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private Students(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      int mutable_bitField0_ = 0;
      com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              if (!((mutable_bitField0_ & 0x00000001) != 0)) {
                account_ = new java.util.ArrayList<model.StudentProto.Student>();
                mutable_bitField0_ |= 0x00000001;
              }
              account_.add(
                  input.readMessage(model.StudentProto.Student.parser(), extensionRegistry));
              break;
            }
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        if (((mutable_bitField0_ & 0x00000001) != 0)) {
          account_ = java.util.Collections.unmodifiableList(account_);
        }
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return model.StudentProto.internal_static_model_Students_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return model.StudentProto.internal_static_model_Students_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              model.StudentProto.Students.class, model.StudentProto.Students.Builder.class);
    }

    public static final int ACCOUNT_FIELD_NUMBER = 1;
    private java.util.List<model.StudentProto.Student> account_;
    /**
     * <code>repeated .model.Student account = 1;</code>
     */
    public java.util.List<model.StudentProto.Student> getAccountList() {
      return account_;
    }
    /**
     * <code>repeated .model.Student account = 1;</code>
     */
    public java.util.List<? extends model.StudentProto.StudentOrBuilder> 
        getAccountOrBuilderList() {
      return account_;
    }
    /**
     * <code>repeated .model.Student account = 1;</code>
     */
    public int getAccountCount() {
      return account_.size();
    }
    /**
     * <code>repeated .model.Student account = 1;</code>
     */
    public model.StudentProto.Student getAccount(int index) {
      return account_.get(index);
    }
    /**
     * <code>repeated .model.Student account = 1;</code>
     */
    public model.StudentProto.StudentOrBuilder getAccountOrBuilder(
        int index) {
      return account_.get(index);
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      for (int i = 0; i < account_.size(); i++) {
        output.writeMessage(1, account_.get(i));
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      for (int i = 0; i < account_.size(); i++) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(1, account_.get(i));
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof model.StudentProto.Students)) {
        return super.equals(obj);
      }
      model.StudentProto.Students other = (model.StudentProto.Students) obj;

      if (!getAccountList()
          .equals(other.getAccountList())) return false;
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (getAccountCount() > 0) {
        hash = (37 * hash) + ACCOUNT_FIELD_NUMBER;
        hash = (53 * hash) + getAccountList().hashCode();
      }
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static model.StudentProto.Students parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static model.StudentProto.Students parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static model.StudentProto.Students parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static model.StudentProto.Students parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static model.StudentProto.Students parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static model.StudentProto.Students parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static model.StudentProto.Students parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static model.StudentProto.Students parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static model.StudentProto.Students parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static model.StudentProto.Students parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static model.StudentProto.Students parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static model.StudentProto.Students parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(model.StudentProto.Students prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * Protobuf type {@code model.Students}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:model.Students)
        model.StudentProto.StudentsOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return model.StudentProto.internal_static_model_Students_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return model.StudentProto.internal_static_model_Students_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                model.StudentProto.Students.class, model.StudentProto.Students.Builder.class);
      }

      // Construct using model.StudentProto.Students.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
          getAccountFieldBuilder();
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        if (accountBuilder_ == null) {
          account_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000001);
        } else {
          accountBuilder_.clear();
        }
        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return model.StudentProto.internal_static_model_Students_descriptor;
      }

      @java.lang.Override
      public model.StudentProto.Students getDefaultInstanceForType() {
        return model.StudentProto.Students.getDefaultInstance();
      }

      @java.lang.Override
      public model.StudentProto.Students build() {
        model.StudentProto.Students result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public model.StudentProto.Students buildPartial() {
        model.StudentProto.Students result = new model.StudentProto.Students(this);
        int from_bitField0_ = bitField0_;
        if (accountBuilder_ == null) {
          if (((bitField0_ & 0x00000001) != 0)) {
            account_ = java.util.Collections.unmodifiableList(account_);
            bitField0_ = (bitField0_ & ~0x00000001);
          }
          result.account_ = account_;
        } else {
          result.account_ = accountBuilder_.build();
        }
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof model.StudentProto.Students) {
          return mergeFrom((model.StudentProto.Students)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(model.StudentProto.Students other) {
        if (other == model.StudentProto.Students.getDefaultInstance()) return this;
        if (accountBuilder_ == null) {
          if (!other.account_.isEmpty()) {
            if (account_.isEmpty()) {
              account_ = other.account_;
              bitField0_ = (bitField0_ & ~0x00000001);
            } else {
              ensureAccountIsMutable();
              account_.addAll(other.account_);
            }
            onChanged();
          }
        } else {
          if (!other.account_.isEmpty()) {
            if (accountBuilder_.isEmpty()) {
              accountBuilder_.dispose();
              accountBuilder_ = null;
              account_ = other.account_;
              bitField0_ = (bitField0_ & ~0x00000001);
              accountBuilder_ = 
                com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                   getAccountFieldBuilder() : null;
            } else {
              accountBuilder_.addAllMessages(other.account_);
            }
          }
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        model.StudentProto.Students parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (model.StudentProto.Students) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      private java.util.List<model.StudentProto.Student> account_ =
        java.util.Collections.emptyList();
      private void ensureAccountIsMutable() {
        if (!((bitField0_ & 0x00000001) != 0)) {
          account_ = new java.util.ArrayList<model.StudentProto.Student>(account_);
          bitField0_ |= 0x00000001;
         }
      }

      private com.google.protobuf.RepeatedFieldBuilderV3<
          model.StudentProto.Student, model.StudentProto.Student.Builder, model.StudentProto.StudentOrBuilder> accountBuilder_;

      /**
       * <code>repeated .model.Student account = 1;</code>
       */
      public java.util.List<model.StudentProto.Student> getAccountList() {
        if (accountBuilder_ == null) {
          return java.util.Collections.unmodifiableList(account_);
        } else {
          return accountBuilder_.getMessageList();
        }
      }
      /**
       * <code>repeated .model.Student account = 1;</code>
       */
      public int getAccountCount() {
        if (accountBuilder_ == null) {
          return account_.size();
        } else {
          return accountBuilder_.getCount();
        }
      }
      /**
       * <code>repeated .model.Student account = 1;</code>
       */
      public model.StudentProto.Student getAccount(int index) {
        if (accountBuilder_ == null) {
          return account_.get(index);
        } else {
          return accountBuilder_.getMessage(index);
        }
      }
      /**
       * <code>repeated .model.Student account = 1;</code>
       */
      public Builder setAccount(
          int index, model.StudentProto.Student value) {
        if (accountBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureAccountIsMutable();
          account_.set(index, value);
          onChanged();
        } else {
          accountBuilder_.setMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .model.Student account = 1;</code>
       */
      public Builder setAccount(
          int index, model.StudentProto.Student.Builder builderForValue) {
        if (accountBuilder_ == null) {
          ensureAccountIsMutable();
          account_.set(index, builderForValue.build());
          onChanged();
        } else {
          accountBuilder_.setMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .model.Student account = 1;</code>
       */
      public Builder addAccount(model.StudentProto.Student value) {
        if (accountBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureAccountIsMutable();
          account_.add(value);
          onChanged();
        } else {
          accountBuilder_.addMessage(value);
        }
        return this;
      }
      /**
       * <code>repeated .model.Student account = 1;</code>
       */
      public Builder addAccount(
          int index, model.StudentProto.Student value) {
        if (accountBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureAccountIsMutable();
          account_.add(index, value);
          onChanged();
        } else {
          accountBuilder_.addMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .model.Student account = 1;</code>
       */
      public Builder addAccount(
          model.StudentProto.Student.Builder builderForValue) {
        if (accountBuilder_ == null) {
          ensureAccountIsMutable();
          account_.add(builderForValue.build());
          onChanged();
        } else {
          accountBuilder_.addMessage(builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .model.Student account = 1;</code>
       */
      public Builder addAccount(
          int index, model.StudentProto.Student.Builder builderForValue) {
        if (accountBuilder_ == null) {
          ensureAccountIsMutable();
          account_.add(index, builderForValue.build());
          onChanged();
        } else {
          accountBuilder_.addMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .model.Student account = 1;</code>
       */
      public Builder addAllAccount(
          java.lang.Iterable<? extends model.StudentProto.Student> values) {
        if (accountBuilder_ == null) {
          ensureAccountIsMutable();
          com.google.protobuf.AbstractMessageLite.Builder.addAll(
              values, account_);
          onChanged();
        } else {
          accountBuilder_.addAllMessages(values);
        }
        return this;
      }
      /**
       * <code>repeated .model.Student account = 1;</code>
       */
      public Builder clearAccount() {
        if (accountBuilder_ == null) {
          account_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000001);
          onChanged();
        } else {
          accountBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>repeated .model.Student account = 1;</code>
       */
      public Builder removeAccount(int index) {
        if (accountBuilder_ == null) {
          ensureAccountIsMutable();
          account_.remove(index);
          onChanged();
        } else {
          accountBuilder_.remove(index);
        }
        return this;
      }
      /**
       * <code>repeated .model.Student account = 1;</code>
       */
      public model.StudentProto.Student.Builder getAccountBuilder(
          int index) {
        return getAccountFieldBuilder().getBuilder(index);
      }
      /**
       * <code>repeated .model.Student account = 1;</code>
       */
      public model.StudentProto.StudentOrBuilder getAccountOrBuilder(
          int index) {
        if (accountBuilder_ == null) {
          return account_.get(index);  } else {
          return accountBuilder_.getMessageOrBuilder(index);
        }
      }
      /**
       * <code>repeated .model.Student account = 1;</code>
       */
      public java.util.List<? extends model.StudentProto.StudentOrBuilder> 
           getAccountOrBuilderList() {
        if (accountBuilder_ != null) {
          return accountBuilder_.getMessageOrBuilderList();
        } else {
          return java.util.Collections.unmodifiableList(account_);
        }
      }
      /**
       * <code>repeated .model.Student account = 1;</code>
       */
      public model.StudentProto.Student.Builder addAccountBuilder() {
        return getAccountFieldBuilder().addBuilder(
            model.StudentProto.Student.getDefaultInstance());
      }
      /**
       * <code>repeated .model.Student account = 1;</code>
       */
      public model.StudentProto.Student.Builder addAccountBuilder(
          int index) {
        return getAccountFieldBuilder().addBuilder(
            index, model.StudentProto.Student.getDefaultInstance());
      }
      /**
       * <code>repeated .model.Student account = 1;</code>
       */
      public java.util.List<model.StudentProto.Student.Builder> 
           getAccountBuilderList() {
        return getAccountFieldBuilder().getBuilderList();
      }
      private com.google.protobuf.RepeatedFieldBuilderV3<
          model.StudentProto.Student, model.StudentProto.Student.Builder, model.StudentProto.StudentOrBuilder> 
          getAccountFieldBuilder() {
        if (accountBuilder_ == null) {
          accountBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
              model.StudentProto.Student, model.StudentProto.Student.Builder, model.StudentProto.StudentOrBuilder>(
                  account_,
                  ((bitField0_ & 0x00000001) != 0),
                  getParentForChildren(),
                  isClean());
          account_ = null;
        }
        return accountBuilder_;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:model.Students)
    }

    // @@protoc_insertion_point(class_scope:model.Students)
    private static final model.StudentProto.Students DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new model.StudentProto.Students();
    }

    public static model.StudentProto.Students getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<Students>
        PARSER = new com.google.protobuf.AbstractParser<Students>() {
      @java.lang.Override
      public Students parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return new Students(input, extensionRegistry);
      }
    };

    public static com.google.protobuf.Parser<Students> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<Students> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public model.StudentProto.Students getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface StudentOrBuilder extends
      // @@protoc_insertion_point(interface_extends:model.Student)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <code>int32 id = 1;</code>
     * @return The id.
     */
    int getId();

    /**
     * <code>string number = 2;</code>
     * @return The number.
     */
    java.lang.String getNumber();
    /**
     * <code>string number = 2;</code>
     * @return The bytes for number.
     */
    com.google.protobuf.ByteString
        getNumberBytes();

    /**
     * <code>int32 customer_id = 3;</code>
     * @return The customerId.
     */
    int getCustomerId();
  }
  /**
   * Protobuf type {@code model.Student}
   */
  public  static final class Student extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:model.Student)
      StudentOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use Student.newBuilder() to construct.
    private Student(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private Student() {
      number_ = "";
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new Student();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private Student(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 8: {

              id_ = input.readInt32();
              break;
            }
            case 18: {
              java.lang.String s = input.readStringRequireUtf8();

              number_ = s;
              break;
            }
            case 24: {

              customerId_ = input.readInt32();
              break;
            }
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return model.StudentProto.internal_static_model_Student_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return model.StudentProto.internal_static_model_Student_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              model.StudentProto.Student.class, model.StudentProto.Student.Builder.class);
    }

    public static final int ID_FIELD_NUMBER = 1;
    private int id_;
    /**
     * <code>int32 id = 1;</code>
     * @return The id.
     */
    public int getId() {
      return id_;
    }

    public static final int NUMBER_FIELD_NUMBER = 2;
    private volatile java.lang.Object number_;
    /**
     * <code>string number = 2;</code>
     * @return The number.
     */
    public java.lang.String getNumber() {
      java.lang.Object ref = number_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        number_ = s;
        return s;
      }
    }
    /**
     * <code>string number = 2;</code>
     * @return The bytes for number.
     */
    public com.google.protobuf.ByteString
        getNumberBytes() {
      java.lang.Object ref = number_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        number_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    public static final int CUSTOMER_ID_FIELD_NUMBER = 3;
    private int customerId_;
    /**
     * <code>int32 customer_id = 3;</code>
     * @return The customerId.
     */
    public int getCustomerId() {
      return customerId_;
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (id_ != 0) {
        output.writeInt32(1, id_);
      }
      if (!getNumberBytes().isEmpty()) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 2, number_);
      }
      if (customerId_ != 0) {
        output.writeInt32(3, customerId_);
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (id_ != 0) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(1, id_);
      }
      if (!getNumberBytes().isEmpty()) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(2, number_);
      }
      if (customerId_ != 0) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(3, customerId_);
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof model.StudentProto.Student)) {
        return super.equals(obj);
      }
      model.StudentProto.Student other = (model.StudentProto.Student) obj;

      if (getId()
          != other.getId()) return false;
      if (!getNumber()
          .equals(other.getNumber())) return false;
      if (getCustomerId()
          != other.getCustomerId()) return false;
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + ID_FIELD_NUMBER;
      hash = (53 * hash) + getId();
      hash = (37 * hash) + NUMBER_FIELD_NUMBER;
      hash = (53 * hash) + getNumber().hashCode();
      hash = (37 * hash) + CUSTOMER_ID_FIELD_NUMBER;
      hash = (53 * hash) + getCustomerId();
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static model.StudentProto.Student parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static model.StudentProto.Student parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static model.StudentProto.Student parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static model.StudentProto.Student parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static model.StudentProto.Student parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static model.StudentProto.Student parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static model.StudentProto.Student parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static model.StudentProto.Student parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static model.StudentProto.Student parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static model.StudentProto.Student parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static model.StudentProto.Student parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static model.StudentProto.Student parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(model.StudentProto.Student prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * Protobuf type {@code model.Student}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:model.Student)
        model.StudentProto.StudentOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return model.StudentProto.internal_static_model_Student_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return model.StudentProto.internal_static_model_Student_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                model.StudentProto.Student.class, model.StudentProto.Student.Builder.class);
      }

      // Construct using model.StudentProto.Student.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        id_ = 0;

        number_ = "";

        customerId_ = 0;

        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return model.StudentProto.internal_static_model_Student_descriptor;
      }

      @java.lang.Override
      public model.StudentProto.Student getDefaultInstanceForType() {
        return model.StudentProto.Student.getDefaultInstance();
      }

      @java.lang.Override
      public model.StudentProto.Student build() {
        model.StudentProto.Student result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public model.StudentProto.Student buildPartial() {
        model.StudentProto.Student result = new model.StudentProto.Student(this);
        result.id_ = id_;
        result.number_ = number_;
        result.customerId_ = customerId_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof model.StudentProto.Student) {
          return mergeFrom((model.StudentProto.Student)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(model.StudentProto.Student other) {
        if (other == model.StudentProto.Student.getDefaultInstance()) return this;
        if (other.getId() != 0) {
          setId(other.getId());
        }
        if (!other.getNumber().isEmpty()) {
          number_ = other.number_;
          onChanged();
        }
        if (other.getCustomerId() != 0) {
          setCustomerId(other.getCustomerId());
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        model.StudentProto.Student parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (model.StudentProto.Student) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }

      private int id_ ;
      /**
       * <code>int32 id = 1;</code>
       * @return The id.
       */
      public int getId() {
        return id_;
      }
      /**
       * <code>int32 id = 1;</code>
       * @param value The id to set.
       * @return This builder for chaining.
       */
      public Builder setId(int value) {
        
        id_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>int32 id = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearId() {
        
        id_ = 0;
        onChanged();
        return this;
      }

      private java.lang.Object number_ = "";
      /**
       * <code>string number = 2;</code>
       * @return The number.
       */
      public java.lang.String getNumber() {
        java.lang.Object ref = number_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs =
              (com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          number_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>string number = 2;</code>
       * @return The bytes for number.
       */
      public com.google.protobuf.ByteString
          getNumberBytes() {
        java.lang.Object ref = number_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          number_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>string number = 2;</code>
       * @param value The number to set.
       * @return This builder for chaining.
       */
      public Builder setNumber(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  
        number_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>string number = 2;</code>
       * @return This builder for chaining.
       */
      public Builder clearNumber() {
        
        number_ = getDefaultInstance().getNumber();
        onChanged();
        return this;
      }
      /**
       * <code>string number = 2;</code>
       * @param value The bytes for number to set.
       * @return This builder for chaining.
       */
      public Builder setNumberBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
        
        number_ = value;
        onChanged();
        return this;
      }

      private int customerId_ ;
      /**
       * <code>int32 customer_id = 3;</code>
       * @return The customerId.
       */
      public int getCustomerId() {
        return customerId_;
      }
      /**
       * <code>int32 customer_id = 3;</code>
       * @param value The customerId to set.
       * @return This builder for chaining.
       */
      public Builder setCustomerId(int value) {
        
        customerId_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>int32 customer_id = 3;</code>
       * @return This builder for chaining.
       */
      public Builder clearCustomerId() {
        
        customerId_ = 0;
        onChanged();
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:model.Student)
    }

    // @@protoc_insertion_point(class_scope:model.Student)
    private static final model.StudentProto.Student DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new model.StudentProto.Student();
    }

    public static model.StudentProto.Student getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<Student>
        PARSER = new com.google.protobuf.AbstractParser<Student>() {
      @java.lang.Override
      public Student parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return new Student(input, extensionRegistry);
      }
    };

    public static com.google.protobuf.Parser<Student> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<Student> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public model.StudentProto.Student getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_model_Students_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_model_Students_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_model_Student_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_model_Student_fieldAccessorTable;

  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static  com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\n\016baeldung.proto\022\005model\"+\n\010Students\022\037\n\007a" +
      "ccount\030\001 \003(\0132\016.model.Student\":\n\007Student\022" +
      "\n\n\002id\030\001 \001(\005\022\016\n\006number\030\002 \001(\t\022\023\n\013customer_" +
      "id\030\003 \001(\005B\016B\014StudentProtob\006proto3"
    };
    descriptor = com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
        });
    internal_static_model_Students_descriptor =
      getDescriptor().getMessageTypes().get(0);
    internal_static_model_Students_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_model_Students_descriptor,
        new java.lang.String[] { "Account", });
    internal_static_model_Student_descriptor =
      getDescriptor().getMessageTypes().get(1);
    internal_static_model_Student_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_model_Student_descriptor,
        new java.lang.String[] { "Id", "Number", "CustomerId", });
  }

  // @@protoc_insertion_point(outer_class_scope)
}
